/// Hybrid sequential/parallel reduction using MULTIPLE work groups
__kernel void hybrid_reduce(
  __global int* input,    // the input array
  const unsigned length,  // full length of the input array
  __global int* result,   // output
  __local int* scratch)   // host-allocated local memory
{ 
  int l_id = get_local_id(0);
  
  // Loop sequentially over chunks of input vector
  // Sum elemts over chunks, then fill up local memory
  int sum = 0;
  for (
    int g_id = get_global_id(0); // start from workitem
    g_id < length;               // while still in the input
    g_id += get_global_size(0);) // jump workgroup-sized chunks
  {
    // TODO
  }
  scratch[l_id] = sum;

  barrier(CLK_LOCAL_MEM_FENCE);

  // Perform parallel reduction
  for (int offset = get_local_size(0) / 2; offset > 0; offset /= 2) {
    if (/*TODO*/) {
      // TODO
    }
    // TODO
  }

  // write result for this block to global mem
  if (l_id == 0) {
    result[get_group_id(0)] = scratch[0];
  }
}

/// Parallel reduction on a SINGLE work group
__kernel void parallel_reduce(
  __global int* input, 
  __global int* result,
  __local int* scratch) // host-allocated local memory
{
  int l_id = get_local_id(0);

  scratch[l_id] = input[l_id];

  barrier(CLK_LOCAL_MEM_FENCE);

  // Perform parallel reduction
  for (int offset = get_local_size(0) / 2; offset > 0; offset /= 2) {
    if (/*TODO*/) {
      // TODO
    }
    // TODO
  }

  // write result for this block to global mem
  if (l_id == 0) {
    *result = scratch[0];
  }
}